# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`telegraf`](#telegraf): == Class: telegraf  A Puppet module for installing InfluxData's Telegraf  === Parameters  [*package_name*]   String. Package name.  [*ensure*
* [`telegraf::config`](#telegrafconfig): == Class: telegraf::config  Templated generation of telegraf.conf
* [`telegraf::install`](#telegrafinstall): == Class: telegraf::install  Conditionally handle InfluxData's official repos and install the necessary Telegraf package.
* [`telegraf::params`](#telegrafparams): == Class: telegraf::params  A set of default parameters for Telegraf's configuration.
* [`telegraf::service`](#telegrafservice): == Class: telegraf::service  Optionally manage the Telegraf service.

### Defined types

* [`telegraf::aggregator`](#telegrafaggregator)
* [`telegraf::input`](#telegrafinput)
* [`telegraf::output`](#telegrafoutput)
* [`telegraf::processor`](#telegrafprocessor)

## Classes

### `telegraf`

== Class: telegraf

A Puppet module for installing InfluxData's Telegraf

=== Parameters

[*package_name*]
  String. Package name.

[*ensure*]
  String. State of the telegraf package. You can also specify a
  particular version to install.

[*config_file*]
  String. Path to the configuration file.

[*logfile*]
  String. Path to the log file.

[*config_file_owner*]
  String. User to own the telegraf config file.

[*config_file_group*]
  String. Group to own the telegraf config file.

[*config_file_mode*]
  String. File mode for the telegraf config file.

[*config_folder*]
  String. Path of additional telegraf config folder.

[*config_folder_mode*]
  String. File mode for the telegraf config folder.

[*hostname*]
  String. Override default hostname used to identify this agent.

[*omit_hostname*]
  Boolean. Do not set the "host" tag in the telegraf agent.

[*interval*]
  String. Default data collection interval for all inputs.

[*round_interval*]
  Boolean. Rounds collection interval to 'interval'

[*metric_batch_size*] Integer. The maximum batch size to allow to
  accumulate before sending a flush to the configured outputs

[*metric_buffer_limit*] Integer.  The absolute maximum number of
  metrics that will accumulate before metrics are dropped.

[*collection_jitter*]
  String.  Sleep for a random time within jitter before collecting.

[*flush_interval*]
  String. Default flushing interval for all outputs.

[*flush_jitter*]
  String.  Jitter the flush interval by an amount.

[*debug*]
  Boolean. Run telegraf in debug mode.

[*quiet*]
  Boolean.  Run telegraf in quiet mode.

[*outputs*]
  Hash. Specify output plugins and their options.

[*inputs*]
  Hash.  Specify input plugins and their options.

[*global_tags*]
  Hash.  Global tags as a key-value pair.

[*manage_service*]
  Boolean.  Whether to manage the telegraf service or not.

[*manage_repo*]
  Boolean.  Whether or not to manage InfluxData's repo.

[*manage_archive*]
  Boolean.  Whether or not to manage InfluxData's tar archive.

[*repo_location*]
  String. Alternate repo location. E.g. an interal mirror.

[*archive_location*]
  String. Alternate archive location. E.g. an interal mirror.

[*archive_install_dir*]
  String. Location to extract archive to must be an absolute path

[*install_options*]
  String or Array. Additional options to pass when installing package

[*purge_config_fragments*]
  Boolean. Whether unmanaged configuration fragments should be removed.

[*repo_type*]
  String.  Which repo (stable, unstable, nightly) to use

[*windows_package_url*]
  String.  URL for windows telegraf chocolatey repo

#### Parameters

The following parameters are available in the `telegraf` class.

##### `package_name`

Data type: `String`



Default value: `$telegraf::params::package_name`

##### `ensure`

Data type: `String`



Default value: `$telegraf::params::ensure`

##### `config_file`

Data type: `String`



Default value: `$telegraf::params::config_file`

##### `config_file_owner`

Data type: `String`



Default value: `$telegraf::params::config_file_owner`

##### `config_file_group`

Data type: `String`



Default value: `$telegraf::params::config_file_group`

##### `config_file_mode`

Data type: `Stdlib::Filemode`



Default value: `$telegraf::params::config_file_mode`

##### `config_folder`

Data type: `String`



Default value: `$telegraf::params::config_folder`

##### `config_folder_mode`

Data type: `Stdlib::Filemode`



Default value: `$telegraf::params::config_folder_mode`

##### `hostname`

Data type: `String`



Default value: `$telegraf::params::hostname`

##### `omit_hostname`

Data type: `Boolean`



Default value: `$telegraf::params::omit_hostname`

##### `interval`

Data type: `String`



Default value: `$telegraf::params::interval`

##### `round_interval`

Data type: `Boolean`



Default value: `$telegraf::params::round_interval`

##### `metric_batch_size`

Data type: `Integer`



Default value: `$telegraf::params::metric_batch_size`

##### `metric_buffer_limit`

Data type: `Integer`



Default value: `$telegraf::params::metric_buffer_limit`

##### `collection_jitter`

Data type: `String`



Default value: `$telegraf::params::collection_jitter`

##### `flush_interval`

Data type: `String`



Default value: `$telegraf::params::flush_interval`

##### `flush_jitter`

Data type: `String`



Default value: `$telegraf::params::flush_jitter`

##### `precision`

Data type: `String`



Default value: `$telegraf::params::precision`

##### `logfile`

Data type: `String`



Default value: `$telegraf::params::logfile`

##### `debug`

Data type: `Boolean`



Default value: `$telegraf::params::debug`

##### `quiet`

Data type: `Boolean`



Default value: `$telegraf::params::quiet`

##### `inputs`

Data type: `Hash`



Default value: `$telegraf::params::inputs`

##### `outputs`

Data type: `Hash`



Default value: `$telegraf::params::outputs`

##### `global_tags`

Data type: `Hash`



Default value: `$telegraf::params::global_tags`

##### `manage_service`

Data type: `Boolean`



Default value: `$telegraf::params::manage_service`

##### `manage_repo`

Data type: `Boolean`



Default value: `$telegraf::params::manage_repo`

##### `manage_archive`

Data type: `Boolean`



Default value: `$telegraf::params::manage_archive`

##### `repo_location`

Data type: `Optional[String]`



Default value: `$telegraf::params::repo_location`

##### `archive_location`

Data type: `Optional[String]`



Default value: `$telegraf::params::archive_location`

##### `archive_install_dir`

Data type: `Optional[String]`



Default value: `$telegraf::params::archive_install_dir`

##### `purge_config_fragments`

Data type: `Boolean`



Default value: `$telegraf::params::purge_config_fragments`

##### `repo_type`

Data type: `String`



Default value: `$telegraf::params::repo_type`

##### `windows_package_url`

Data type: `String`



Default value: `$telegraf::params::windows_package_url`

##### `service_enable`

Data type: `Boolean`



Default value: `$telegraf::params::service_enable`

##### `service_ensure`

Data type: `String`



Default value: `$telegraf::params::service_ensure`

##### `install_options`

Data type: `Array`



Default value: `$telegraf::params::install_options`

### `telegraf::config`

== Class: telegraf::config

Templated generation of telegraf.conf

### `telegraf::install`

== Class: telegraf::install

Conditionally handle InfluxData's official repos and install the necessary
Telegraf package.

### `telegraf::params`

== Class: telegraf::params

A set of default parameters for Telegraf's configuration.

### `telegraf::service`

== Class: telegraf::service

Optionally manage the Telegraf service.

## Defined types

### `telegraf::aggregator`

The telegraf::aggregator class.

#### Parameters

The following parameters are available in the `telegraf::aggregator` defined type.

##### `plugin_type`

Data type: `String`



Default value: `$name`

##### `options`

Data type: `Optional[Array]`



Default value: ``undef``

### `telegraf::input`

The telegraf::input class.

#### Parameters

The following parameters are available in the `telegraf::input` defined type.

##### `plugin_type`

Data type: `String`



Default value: `$name`

##### `options`

Data type: `Array`



Default value: `[]`

### `telegraf::output`

The telegraf::output class.

#### Parameters

The following parameters are available in the `telegraf::output` defined type.

##### `plugin_type`

Data type: `String`



Default value: `$name`

##### `options`

Data type: `Optional[Array]`



Default value: ``undef``

### `telegraf::processor`

The telegraf::processor class.

#### Parameters

The following parameters are available in the `telegraf::processor` defined type.

##### `plugin_type`

Data type: `String`



Default value: `$name`

##### `options`

Data type: `Optional[Array]`



Default value: ``undef``

